Number of Flowers in Full Bloom - Leetcode 2251 - Python

Sdílet
Vložit
  • čas přidán 27. 07. 2024
  • 🚀 neetcode.io/ - A better way to prepare for Coding Interviews
    🥷 Discord: / discord
    🐦 Twitter: / neetcode1
    🐮 Support the channel: / neetcode
    ⭐ BLIND-75 PLAYLIST: • Two Sum - Leetcode 1 -...
    💡 DYNAMIC PROGRAMMING PLAYLIST: • House Robber - Leetco...
    Problem Link: leetcode.com/problems/number-...
    0:00 - Read the problem
    0:30 - Drawing Explanation
    9:22 - Coding Explanation
    9:22 - Time and Space explanation
    16:26 - Slight Optimization
    leetcode 2251
    #neetcode #leetcode #python

Komentáře • 40

  • @akhilasulgante9907
    @akhilasulgante9907 Před 9 měsíci +5

    Saviour!!
    Also, am I missing something because it is mentioned as "1

  • @gn01737625
    @gn01737625 Před 9 měsíci +6

    Hi NeetCode, the length of people array is also 5*10^4(as same as flowers.length).
    10^9 is the range of people's arrival time

    • @NeetCodeIO
      @NeetCodeIO  Před 9 měsíci +1

      Whoops, I misread that. I still believe the overall time complexity that i mentioned doesn't change though, correct me if i'm wrong.

    • @TechBytes208
      @TechBytes208 Před 9 měsíci +2

      ​@@NeetCodeIOactually their complexity is also correct since mlogn and nlogn are now same

  • @MP-ny3ep
    @MP-ny3ep Před 9 měsíci +1

    Great explanation as always. Thank you

  • @createthiscom
    @createthiscom Před 4 měsíci

    Two sorted arrays also work to solve this problem, which is good if you're using something like JS that doesn't have native heap data types. It's twice as slow, but it's still "fast enough".

  • @parthfilmz
    @parthfilmz Před 9 měsíci

    Thanks man for uploading this one, was searching on yt for this problem ,could not find good explanation

  • @sudhanshupandey6096
    @sudhanshupandey6096 Před 9 měsíci +3

    What about discrete Maths?Please Launch a course on it.

  • @lazyemperor5182
    @lazyemperor5182 Před 9 měsíci +1

    Lovin the vids keep em coming

  • @AliMalik-yt5ex
    @AliMalik-yt5ex Před 9 měsíci +1

    Love the content 🎉

  • @swanv951
    @swanv951 Před 9 měsíci +1

    Nice solutions. A small optimization would be to not add flowers whose bloom has already ended to the 'end' heap. @NeetCodeIO, do you get the solutions for such problems in 15 or so mins, which would be required in a real interview?

  • @enrico8730
    @enrico8730 Před 9 měsíci

    Can’t wait for the oop design course!

  • @abhinavnarula7300
    @abhinavnarula7300 Před 9 měsíci +2

    Thanks for the intution NeetCode. i just wanted to ask you how do i recognize this pattern of problems like how should i even think about this sort of a solution of using heap in this question. Not only this question but for other hard questions as well.

    • @NeetCodeIO
      @NeetCodeIO  Před 9 měsíci +2

      In this case, this problem reminds me of an easier interval problem i solved, i think it was either Meeting Rooms I or II. (it's in the Neetcode 150 list)

    • @abhinavnarula7300
      @abhinavnarula7300 Před 9 měsíci

      @@NeetCodeIO Thank u very much ❤️❤️❤️

  • @xinruijiang6670
    @xinruijiang6670 Před 9 měsíci

    Love this tutorial video! Just have a question. Why used heap sort here? Is heap sort better than other sorting algorithms in this case? Thanks. 😊

  • @pranav2066
    @pranav2066 Před 9 měsíci +2

    Great solution. Slightly tougher to come up with in a real interview but at least you are making our thought process clearer.
    Just one thing, this question has been asked by Google, not Meta. Thumbnail is incorrect 😅.

  • @comatosesperrow
    @comatosesperrow Před 9 měsíci

    Is there a reason we can't loop over each person, check if they are in the bounds of each flower, and increment a counter? It's O(m*n) runtime. I don't see complexity requirements in the question.

  • @satwiktatikonda764
    @satwiktatikonda764 Před 9 měsíci +1

    hi neetcode,I used prefix sum and carry forward approach but it is giving memory error
    maxi=float('-inf')
    for l,r in flowers:
    maxi=max(maxi,r)
    zero=[0]*(maxi+1)
    for l,r in flowers:
    zero[l-1]+=1
    zero[r]-=1

    for i in range(1,len(zero)):
    zero[i]=zero[i-1]+zero[i]

    for p in people:
    if p-1>maxi:
    zero.append(0)
    else:
    zero.append(zero[p-1])
    return zero[maxi+1:]
    I believe that this solution has linear time and linear space , can anyone help me with this!!

    • @pritz9
      @pritz9 Před 9 měsíci

      Yeah ,even I came up with this approach, but mine passed 32/52 test cases and got memory limit exceeded after that!

    • @satwiktatikonda764
      @satwiktatikonda764 Před 9 měsíci

      @@pritz9 the reason why it's not working is max value of r can be 10**9 and I am initialising zero array with size of 10**9 wch causes memory error

    • @pritz9
      @pritz9 Před 9 měsíci

      @@satwiktatikonda764yeah I got that earlier, I just let u know that you aren't the only one :-(

  • @rechw769
    @rechw769 Před 9 měsíci

    hoho

  • @bekmurat7298
    @bekmurat7298 Před 9 měsíci

    poeple 3:15

  • @CS_n00b
    @CS_n00b Před 8 měsíci

    why is this hard?

  • @Andrew_J123
    @Andrew_J123 Před 9 měsíci +4

    First!

  • @GeneralistDev
    @GeneralistDev Před 9 měsíci

    I always find it hard to understand your approach/intution in videos. I don't know what's wrong with me unlike others why I don't understand your videos. May be accent, speed is fast etc.

    • @kareemadesola6522
      @kareemadesola6522 Před 9 měsíci +1

      reduce the playback speed to 0.5 or customize to a value suited for you

    • @moneymaker7307
      @moneymaker7307 Před 9 měsíci

      You are probably missing prerequisite. This problem is a simple line sweep problem. Unless you have mastered line sweep then the solution won’t make sense.
      You should probably do a lot easy intervals question before coming to this question

  • @phpostrich
    @phpostrich Před 9 měsíci +1

    I feel like this should be a "medium" problem

    • @annoyingorange90
      @annoyingorange90 Před 9 měsíci

      really unnecessary comment

    • @phpostrich
      @phpostrich Před 9 měsíci

      Aren't all comments unnecessary?

    • @annoyingorange90
      @annoyingorange90 Před 9 měsíci

      @@phpostrich ilooked it up already with the feeling of defeat no need to stomp on me :(

    • @phpostrich
      @phpostrich Před 9 měsíci

      Oh I struggled a bit with this one too, but like compared to the other hard problems idk just seems a little easier

  • @anthonya880
    @anthonya880 Před 9 měsíci

    Please consider making videos with Java also.
    May be you can reach a larger audience.